package example
{

    import flash.display.BitmapData;
    import flash.display.Loader;
    import flash.events.Event;
    import flash.events.EventDispatcher;
    import flash.events.IOErrorEvent;
    import flash.events.SecurityErrorEvent;
    import flash.net.URLRequest;

    import nq.net.assets.loaders.IAssetLoader;

    /**
     * Класс для загрузки графических ихображений
     */
    public final class ExampleImageAssetLoader extends EventDispatcher implements IAssetLoader
    {

        private var _loader:Loader;
        private var _data:Loader;

        public function ExampleImageAssetLoader()
        {
            super();

            _loader = new Loader();
            _data = null;
        }

        public function load(url:String):void
        {
            _loader.contentLoaderInfo.addEventListener(Event.COMPLETE, onComplete);
            _loader.contentLoaderInfo.addEventListener(IOErrorEvent.IO_ERROR, onError);
            _loader.contentLoaderInfo.addEventListener(SecurityErrorEvent.SECURITY_ERROR, onError);

            _loader.load(new URLRequest(url));
        }

        public function close():void
        {
            try {
                _loader.close();
            }catch (error:Error) {
                // ничего не делаем
            }

            super.dispatchEvent(new Event(Event.CANCEL));
        }

        public function get data():Object
        {
            return _data;
        }

        private function onComplete(event:Event):void {
            this.removeListeners();
            _data = _loader;

            super.dispatchEvent(new Event(Event.COMPLETE));
        }

        private function onError(event:IOErrorEvent):void
        {
            this.removeListeners();
            this.close();
        }

        private function removeListeners():void
        {
            _loader.contentLoaderInfo.removeEventListener(Event.COMPLETE, onComplete);
            _loader.contentLoaderInfo.removeEventListener(IOErrorEvent.IO_ERROR, onError);
            _loader.contentLoaderInfo.removeEventListener(SecurityErrorEvent.SECURITY_ERROR, onError);
        }
    }
}
