package example
{
    import nq.net.assets.loaders.IAssetLoader;
    import nq.net.assets.loaders.IAssetLoaderFactory;

    /**
     * Фабрика для формирования загрузчиков под определнный тип контента
     */
    public class ExampleLoaderFactory implements IAssetLoaderFactory
    {
        /**
         * Для получения экземпляра используется статический акцессор instance
         */
        public function ExampleLoaderFactory()
        {
            super();
        }

        /* INTERFACE nq.net.assets.loaders.IAssetLoaderFactory */

        public function getLoader(url:String, mimeType:String = "application/octet-stream"):IAssetLoader
        {
            if (mimeType == "application/octet-stream") {

                return new ExampleBinaryAssetLoader();

            }else if (mimeType == "image/jpg" || mimeType == "image/png") {

                return new ExampleImageAssetLoader();
            }

            throw new Error("Данный MIME-тип не поддерживается!");
        }

    }
}
