package nq.net.assets.storage {

    /**
     * Класс хранилища загружаемых ресурсов
     */
    public final class AssetBundle implements IAssetBundle {

        private var _hash:Object;

        public function AssetBundle() {

            super();

            _hash = new Object();
        }


        /* INTERFACE nq.net.assets.IAssetBundle */

        /**
         * Добавить ассет в пакет ресурсов
         *
         * @param asset Добавляемый ассет
         * @param uri   Уникальное имя ассета в этом пакете
         */
        public function addAsset(asset:Object, uri:String):void {

            if (uri in _hash) throw new ArgumentError("Ассет с URI '"+uri+"' уже зарегистрирован!");

            _hash[uri] = asset;
        }

        /**
         * Имеется ли ассет с таким именем в пакете
         *
         * @param uri   Уникальное имя ассета в этом пакете
         */
        public function hasAsset(uri:String):Boolean {

            return (uri in _hash);
        }

        /**
         * Удалить ассет по имени
         *
         * @param uri   Уникальное имя ассета в этом пакете
         */
        public function removeAsset(uri:String):void {

            if (!(uri in _hash)) throw new ArgumentError("Ассет с таким URI не зарегистрирован!");

            delete _hash[uri];
        }

        /**
         * Получить ассет по имени
         *
         * @param uri   Уникальное имя ассета в этом пакете
         */
        public function getAsset(uri:String):Object {

            if (!(uri in _hash)) throw new ArgumentError("Ассет с таким URI ("+uri+") не зарегистрирован!");

            return _hash[uri];
        }

    }

}
